import Component from '@glimmer/component';
import { scheduleOnce, later } from '@ember/runloop';
import { action } from '@ember/object';
import { precompileTemplate } from '@ember/template-compilation';
import { n } from 'decorator-transforms/runtime';
import { setComponentTemplate } from '@ember/component';

var TEMPLATE = precompileTemplate("{{#if @searchEnabled}}\n  <div class=\"ember-power-select-search\">\n    {{!-- template-lint-disable require-input-label --}}\n    <input type=\"search\"\n      autocomplete=\"off\"\n      autocorrect=\"off\"\n      autocapitalize=\"off\"\n      spellcheck={{false}}\n      class=\"ember-power-select-search-input\"\n      value={{@select.searchText}}\n      role={{or @role \"combobox\"}}\n      aria-activedescendant={{@ariaActiveDescendant}}\n      aria-controls={{@listboxId}}\n      aria-owns={{@listboxId}}\n      aria-autocomplete=\"list\"\n      aria-haspopup=\"listbox\"\n      aria-expanded={{if @select.isOpen \"true\" \"false\"}}\n      placeholder={{@searchPlaceholder}}\n      aria-label={{@ariaLabel}}\n      aria-labelledby={{@ariaLabelledBy}}\n      aria-describedby={{@ariaDescribedBy}}\n      {{on \"input\" this.handleInput}}\n      {{on \"focus\" @onFocus}}\n      {{on \"blur\" @onBlur}}\n      {{on \"keydown\" this.handleKeydown}}\n      {{did-insert this.focusInput}}\n      {{will-destroy this.clearSearch}}>\n  </div>\n{{/if}}");

class PowerSelectBeforeOptionsComponent extends Component {
  clearSearch() {
    scheduleOnce('actions', this.args.select.actions, 'search', '');
  }
  static {
    n(this.prototype, "clearSearch", [action]);
  }
  handleKeydown(e) {
    if (this.args.onKeydown(e) === false) {
      return false;
    }
    if (e.keyCode === 13) {
      this.args.select.actions.close(e);
    }
  }
  static {
    n(this.prototype, "handleKeydown", [action]);
  }
  handleInput(event) {
    const e = event;
    if (this.args.onInput(e) === false) {
      return false;
    }
  }
  static {
    n(this.prototype, "handleInput", [action]);
  }
  focusInput(el) {
    later(() => {
      if (this.args.autofocus !== false) {
        el.focus();
      }
    }, 0);
  }
  static {
    n(this.prototype, "focusInput", [action]);
  }
}
setComponentTemplate(TEMPLATE, PowerSelectBeforeOptionsComponent);

export { PowerSelectBeforeOptionsComponent as default };
//# sourceMappingURL=before-options.js.map
